<!-- label section -->
<div class="app-label-section">
  <!-- label -->
  <div class="app-label">
    {{ label }}
  </div>

  <!-- additional label -->
  <div *ngIf="additionalLabel" class="app-additional-label">
    {{ additionalLabel }}
  </div>
</div>

<!-- control -->
<div class="app-control">
  <!-- switch by type -->
  <ng-container [ngSwitch]="type">
    <!-- input -->
    <ng-container *ngSwitchCase="'input'">
      <input [formControl]="control" [maxlength]="maxLength" [mask]="mask" placeholder="Type Here" appInput />
    </ng-container>

    <!-- text -->
    <ng-container *ngSwitchCase="'text'">
      <textarea [formControl]="control" placeholder="Type Here" appInput></textarea>
    </ng-container>

    <!-- select -->
    <ng-container *ngSwitchCase="'select'">
      <!-- select -->
      <app-select [control]="control" [options]="options" [placeholder]="placeholder"></app-select>
    </ng-container>
  </ng-container>

  <!-- render errors -->
  <ng-container *ngFor="let item of errorCodes">
    <!-- error -->
    <app-field-error *ngIf="hasError(item)">
      {{ errors[item] }}
    </app-field-error>
  </ng-container>
</div>
